local function SafeFreeSlot(...)
	for _,slot in ipairs({...}) do
		if not rawget(_G, slot) freeslot(slot) end -- overlapping = wasting, how do we not waste (as many of) them? don't do it in the first place!
	end
end

SafeFreeSlot("SPR_LEGOBATTLESPROJ","S_KOMBI_SHURIKEN",
"S_KOMBI_BULLETHOLE",
"S_KOMBI_SNARKDIE",
"MT_HL1_BULLET",
"MT_HL1_BOLT",
"MT_HL1_ARGRENADE",
"MT_HL1_ROCKET",
"MT_HL1_HANDGRENADE",
"MT_HL1_SATCHEL",
"MT_HL1_TRIPMINE",
"MT_HL1_SNARK",
"MT_HL1_HORNET",
"S_ONETICINVIS",
"sfx_hl1wpn",
"sfx_hlcbar","sfx_hlcbb1","sfx_hlcbb2","sfx_hlcbb3","sfx_hlcbh1","sfx_hlcbh2",
"sfx_hl1g17","sfx_hl1pr1","sfx_hl1pr2",
"sfx_hl3571","sfx_hl3572","sfx_hl357r",
"sfx_hl1ar1","sfx_hl1ar2","sfx_hl1ar3","sfx_hlarr1","sfx_hlarr2","sfx_hlarg1","sfx_hlarg2",
"sfx_hl1sg1","sfx_hl1sgc","sfx_hldsht","sfx_hl1sr1","sfx_hl1sr2","sfx_hl1sr3",
"sfx_hlxbfr","sfx_hlxbre",
"sfx_hlrckt","sfx_hlexp1","sfx_hlexp2","sfx_hlexp3",
"sfx_hlgrn1","sfx_hlgrn2","sfx_hlgrn3",
"sfx_hltmdp","sfx_hltmch","sfx_hltmac",
"SPR_HLHITEFFECT","S_HL1_HIT",
"SPR_HL1EXPLOSION","S_HL1_EXPLODE","S_HL1_GRENADEEXPLODE","S_HL1_EXPLOSION",
"S_HL1_ROCKET","S_HL1_ROCKETACTIVE",
"S_HL1_TRIPMINETHROWN","S_HL1_INACTIVETRIPMINE","S_HL1_ACTIVETRIPMINE","S_HL1_TRIPLASER","SPR_HL1LASER","SPR_TRIP","MT_HL1_TRIPLASER")

sfxinfo[sfx_hlcbar].caption = "Crowbar Swing"
sfxinfo[sfx_hlcbh1].caption = "*CLANG!*"
sfxinfo[sfx_hlcbh2].caption = "*CLANG!*"
sfxinfo[sfx_hlcbb1].caption = "Crowbar Impact (Body)"
sfxinfo[sfx_hlcbb2].caption = "Crowbar Impact (Body)"
sfxinfo[sfx_hlcbb3].caption = "Crowbar Impact (Body)"
sfxinfo[sfx_hl1sg1].caption = "Shotgun Firing"
sfxinfo[sfx_hldsht].caption = "Double Shotgun Action"
sfxinfo[sfx_hl1sr1].caption = "Shotgun Loading"
sfxinfo[sfx_hl1sr2].caption = "Shotgun Loading"
sfxinfo[sfx_hl1sr3].caption = "Shotgun Loading"
sfxinfo[sfx_hl1g17].caption = "Pistol Firing"
sfxinfo[sfx_hl1pr1].caption = "Pistol Clip Out"
sfxinfo[sfx_hl1pr2].caption = "Pistol Clip In"
sfxinfo[sfx_hl3571].caption = ".357 Firing"
sfxinfo[sfx_hl3572].caption = ".357 Firing"
sfxinfo[sfx_hl357r].caption = ".357 Reloading"
sfxinfo[sfx_hl1ar1].caption = "MP5 Firing"
sfxinfo[sfx_hl1ar2].caption = "MP5 Firing"
sfxinfo[sfx_hl1ar3].caption = "MP5 Firing"
sfxinfo[sfx_hlarr1].caption = "MP5 Clip Out"
sfxinfo[sfx_hlarr2].caption = "MP5 Clip In"
sfxinfo[sfx_hlarg1].caption = "MP5 Grenade Launched"
sfxinfo[sfx_hlarg2].caption = "MP5 Grenade Launched"
sfxinfo[sfx_hlrckt].caption = "Rocket Launched"
sfxinfo[sfx_hlexp1].caption = "Royalty Free Explosion"
sfxinfo[sfx_hlexp2].caption = "Royalty Cheap Explosion"
sfxinfo[sfx_hlexp3].caption = "Royalty Expensive Explosion"

states[S_ONETICINVIS] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_KOMBI_SHURIKEN] = {
	sprite = SPR_LEGOBATTLESPROJ,
	frame = A,
	tics = 18,
	var1 = 0,
	var2 = 0,
	nextstate = S_KOMBI_SHURIKEN
}

states[S_KOMBI_BULLETHOLE] = {
	sprite = SPR_LEGOBATTLESPROJ,
	frame = A|FF_PAPERSPRITE,
	tics = 18,
	var1 = 0,
	var2 = 0,
	nextstate = S_KOMBI_BULLETHOLE
}

states[S_KOMBI_SNARKDIE] = {
	sprite = SPR_LEGOBATTLESPROJ,
	frame = A,
	tics = 18,
	var1 = 0,
	var2 = 0,
	nextstate = S_KOMBI_SHURIKEN
}

mobjinfo[MT_HL1_BULLET] = {
	spawnstate = S_KOMBI_SHURIKEN,
	spawnhealth = 100,
	speed = HL.BULLETSPEED,
	radius = 2*FRACUNIT,
	height = 2*FRACUNIT,
	dispoffset = 4,
	flags = MF_NOGRAVITY,
}

mobjinfo[MT_HL1_BOLT] = {
	spawnstate = S_KOMBI_SHURIKEN,
	spawnhealth = 100,
	speed = 80*FRACUNIT,
	radius = 6*FRACUNIT,
	height = 12*FRACUNIT,
	dispoffset = 4,
	flags = MF_NOGRAVITY,
}

local ff = CV_FindVar("friendlyfire")

-- for some DOG ASS REASON, I HAVE TO PUT THESE HERE. fuck this dumbass game vro

rawset(_G, "kombiHL1SpecialHandlers", { -- rawset to _G to open up modding environment. Ya wanna add your own entry? Go on right ahead! Anybody who doesn't follow this logic are lame asf and they should be shamed for it
-- praying none of these people push an update that breaks our code
	["doomguy"] = function(tmthing,thing, dmg, dmgType)

		-- Map each HL.DMG flag to the desired Doom damage type:
		local hlToDoomMap = {
		  [HL.DMG.SLASH]      = DAMAGETYPE_MELEE,
		  [HL.DMG.CLUB]       = DAMAGETYPE_MELEE,
		  [HL.DMG.BULLET]     = DAMAGETYPE_GUNSHOT,
		  [HL.DMG.CRUSH]      = DAMAGETYPE_EXPLOSION,
		  [HL.DMG.BLAST]      = DAMAGETYPE_EXPLOSION,
		  [HL.DMG.ENERGYBEAM] = DAMAGETYPE_BFGTRACER,
		  [HL.DMG.PLASMA]     = DAMAGETYPE_PLASMA,
		  [HL.DMG.DIRECT]     = DAMAGETYPE_PROJECTILE,
		  -- fallback for anything else
		  [HL.DMG.GENERIC]    = DAMAGETYPE_PROJECTILE,
		}

		-- Define a priority list: highest‐priority flags first
		-- (so BLAST/CRUSH outrank BULLET, which outranks GENERIC, etc.)
		local priority = {
		  HL.DMG.BLAST,
		  HL.DMG.CRUSH,
		  HL.DMG.ENERGYBEAM,
		  HL.DMG.PLASMA,
		  HL.DMG.BULLET,
		  HL.DMG.SLASH,
		  HL.DMG.CLUB,
		  HL.DMG.DIRECT,
		  HL.DMG.GENERIC,
		}

		local function band(a, b)
			local result = 0
			local bitval = 1
			for i = 0, 31 do
				local abit = a % 2
				local bbit = b % 2
				if abit == 1 and bbit == 1 then
					result = result + bitval
				end
				a = $ / 2
				b = $ / 2
				bitval = bitval * 2
			end
			return result
		end

		-- The converter function
		local function HL_ConvertDamageType(hlDamageMask)
			for _, flag in ipairs(priority) do
				if band(hlDamageMask, flag) then
					return hlToDoomMap[flag]
				end
			end
			-- If nothing matched, it’s GENERIC
			return DAMAGETYPE_PROJECTILE
		end

		P_DamageMobj(thing, tmthing, tmthing.target, dmg, HL_ConvertDamageType(dmgType)) -- Lugent forgot that projectiles lobbed by players take priority over the damage argument!! lmao
	end,
	["bj"] = function(tmthing,thing, dmg, dmgType)
		if not thing.player.wolfenstein return end
		thing.player.wolfenstein.health = $-dmg
		P_DamageMobj(thing, tmthing, tmthing.target, 0, 0) -- THANK YOU, BJ, for not forcing me to find a way to manage your wack-ass damage system!!
		if thing.player.wolfenstein.health < 0 --
			P_KillMobj(thing, tmthing, tmthing.target, 0)
		end
	end,
	["duke"] = function(tmthing,thing, dmg, dmgType)
		if not duke_roboinfo then error("Duke was shot, but no roboinfo was found! Please stop breaking the fabric of reality.", 2) end -- If you somehow do this, stop.
		duke_roboinfo[MT_HL1_BULLET] = {unshrinkable = true, damage = dmg , ringslingerdamage = true} -- modify our damage variable just before we hurt Dick Kickem, WAY better than whatever shit i was doing before
		-- ^ for some reason the property to disable hurt invulnerability is labelled "ringslingerdamage"??
		P_DamageMobj(thing, tmthing, tmthing.target, 1, 0) -- this and the one below it don't utilize the last two arguments sadly
	end,
	["tailsguy"] = function(tmthing,thing, dmg, dmgType)
		local damage = dmg or 1
		thing.player.tgvars.health = $-dmg+10
		P_DamageMobj(thing, tmthing, tmthing.target, 100, 0)
		if thing.player.tgvars.health < 0
			P_KillMobj(thing, tmthing, tmthing.target, 0)
		end
		thing.player.powers[pw_flashing] = 0 -- please don't be invulnerable kthxbai
	end,
	["samus"] = function(tmthing,thing, dmg, dmgType)
		TakeSamusEnergy(thing.player,dmg,true,tmthing,tmthing.target) -- Golden Shine being based as ever and allowing us easy and direct access to necessary damage functions
	end,
	["basesamus"] = function(tmthing,thing, dmg, dmgType)
		TakeSamusEnergy(thing.player,dmg,true,tmthing,tmthing.target) -- Golden Shine being based as ever and allowing us easy and direct access to necessary damage functions
	end,
	["mcsteve"] = function(tmthing,thing, dmg, dmgType)
		if not stevehelper return end
		stevehelper.damage(thing.player, inflictor, dmg/5)
	end,
})

rawset(_G, "HL_GetDistance", function(obj1, obj2) -- get distance between two objects; useful for things like explosion damage calculation
	if not obj1 or not obj2 then return 0 end -- Ensure both objects exist

	local dx = obj1.x - obj2.x
	local dy = obj1.y - obj2.y
	local dz = obj1.z - obj2.z

	return FixedHypot(FixedHypot(dx, dy), dz) -- 3D distance calculationd
end)

local damagetypes = {
	{dmgtype = HL.DMG.BURN|HL.DMG.SLOWBURN,  icon = "DMGICON-BURN"},
	{dmgtype = HL.DMG.SHOCK,  icon = "DMGICON-ELEC"},
	{dmgtype = HL.DMG.ACID|HL.DMG.PLASMA,  icon = "DMGICON-CHEM"},
	{dmgtype = HL.DMG.DROWN,  icon = "DMGICON-DRWN"},
	{dmgtype = HL.DMG.NERVEGAS,  icon = "DMGICON-NERV"},
	{dmgtype = HL.DMG.RADIATION,  icon = "DMGICON-RAD"},
	{dmgtype = HL.DMG.POISON,  icon = "DMGICON-POIS"},
	{dmgtype = HL.DMG.FREEZE,  icon = "DMGICON-FREZ"},
}

local function getDmgIcon(player, dmgType)
	for _, entry in ipairs(damagetypes) do
		if (dmgType & entry.dmgtype) ~= 0 then
			local found = false
			for _, existing in ipairs(player.hl.dmgicons) do
				if existing.icon == entry.icon then
					found = true
					break
				end
			end

			if not found then
				table.insert(player.hl.dmgicons, 1, {icon = entry.icon, time = TICRATE*5})
			end
		end
	end

	-- Refresh all clocks to 5*TICRATE
	for _, entry in ipairs(player.hl.dmgicons) do
		entry.clock = 5 * TICRATE
	end
end

local function HL_HandleKillFeed(victim, source, inflictor, dmgType)
	local killerPlayer = nil
	local attacker = ""

	if source then
		local resolvedSource = ((inflictor.flags & MF_MISSILE) or inflictor.stats) and (inflictor.shooter or inflictor.target) or inflictor

		if type(resolvedSource) == "userdata" and userdataType(resolvedSource) != "player_t" then
			if resolvedSource and (resolvedSource ~= victim or (resolvedSource.player and resolvedSource.player ~= victim)) and resolvedSource.player then
				killerPlayer = resolvedSource.player
				attacker = killerPlayer.name
			end
		else
			killerPlayer = resolvedSource
			attacker = killerPlayer and killerPlayer.name or ""
		end
	end

	local killicon = inflictor and ((inflictor.stats and inflictor.stats.killicon) or (inflictor.wepstats and inflictor.wepstats.killicon)) or "HLKILLGENER"
	if killicon == "HLKILLGENER" and ((dmgType or 0) & HL.DMG.CRUSH) then
		killicon = "HLKILLCRUSH"
	end

	if (killerPlayer == nil and not (type(source) == "userdata" and userdataType(source) == "mobj_t")) or victim.player == killerPlayer then
		killerPlayer = ""
	end

	if victim.player and killerPlayer then
		HL_AddKillFeedEntry(victim.player, killerPlayer, killicon)
	end
end

rawset(_G, "HL_DamageGordon", function(thing, tmthing, dmg, dmgType)
	local player = thing and thing.player
	local dmgType = dmgType or 0
	if dmg > 0 then
		local damageDir = -FRACUNIT
		if tmthing and not (dmgType & (HL.DMG.CRUSH|HL.DMG.SONIC)) or HL_GetDistance(thing, tmthing) > 24*FRACUNIT then
			local source = tmthing and tmthing.target or tmthing
			damageDir = abs(AngleFixed(R_PointToAngle2(thing.x, thing.y, tmthing.x, tmthing.y)) - AngleFixed(thing.angle))
		end
		thing.hl1dmgdir = damageDir
		if player and not (dmgType and (dmgType & HL.DMG.FALL)) then
			player.hl1damagetics = 0
			local dmgIcon = getDmgIcon(player, dmgType)
		end
	end

	local hldamage = dmg or (tmthing and tmthing.hl1damage)
	if (not thing.hl.health) then
		HL_InitHealth(thing)
	end

	if hldamage then
		if thing.hl.armor and not ((dmgType or 0) & (HL.DMG.DROWN | HL.DMG.DROWNRECOVER | HL.DMG.FALL))then
			thing.hl.armor = $ - (2 * (hldamage * FRACUNIT) / 5)
			thing.hl.health = $ - hldamage / 5 + min(thing.hl.armor / FRACUNIT, 0)
			thing.hl.health = max($, 0)
			thing.hl.armor = max($, 0)
		else
			thing.hl.health = ($ or 0) - hldamage
		end

		if thing.hl.health <= 0 and not thing.facc then -- Please don't actually kill Facc
			HL_HandleKillFeed(thing, tmthing, tmthing, dmgType)
			P_KillMobj(thing, tmthing, (tmthing and tmthing.target) or tmthing, dmgType)
		end
	end
	
	return thing and thing.hl.health <= 0
end)

rawset(_G, "HL_HurtMobj", function(tmthing, thing, customDamage, customDamageType) -- damage something depending on its health logic
	-- Use the provided damage override if given, otherwise default to tmthing.hl1damage
	local damage = customDamage or tmthing.hl1damage
	local attacker = tmthing and tmthing.target or tmthing
	local victim = thing
	local aplayer
	local vplayer
	local isfriend
	local aplayer
	local vplayer
	if attacker and victim then
		aplayer = attacker.player
		vplayer = victim.player
		local isfriend = false

		if aplayer and vplayer and type(vplayer) == "userdata" and userdataType(vplayer) == "player_t" then
			isfriend = (aplayer.ctfteam == vplayer.ctfteam) and (aplayer ~= vplayer)
		end

		if isfriend and (damage or 0) > 0 and not ff.value then
			return 0
		end
	end
	if (HL.DoTDForestAccomodations and thing.type == MT_TAILSDOLL) then thing.flags = $ | MF_SHOOTABLE end
	if not (thing.flags & MF_SHOOTABLE) then return end -- Return early if we're not supposed to get shot.
	if damage and (not tmthing or not tmthing.hitenemy) -- Don't double tap
		if kombiHL1SpecialHandlers[thing.skin] -- already has its own health system?
			kombiHL1SpecialHandlers[thing.skin](tmthing, thing, damage, customDamageType or 0)
		elseif thing.skin == "kombifreeman"
			P_DamageMobj(thing, tmthing, attacker, damage, customDamageType or 0) -- custom damage type if provided
		elseif thing.facc or thing.breaktime or thing.breakdelay
			-- Silverhorn support
			print(thing.hl.health)
			HL_DamageGordon(thing, tmthing, damage, customDamageType)
			print(thing.hl.health)
			if thing.hl.health <= 0 then
				if thing.facc then
					thing.facc.health = min($, thing.facc.phase)
				end
				if thing.breaktime or thing.breakdelay then
					P_StartQuake(32*FU, TICRATE)
					S_StartSound(nil, sfx_bxdmg)
					thing.state = S_UNA_FORCE_BREAK1
					thing.health = 0
				end
				P_DamageMobj(thing, tmthing, attacker)
			else
				if thing.facc then
					-- Scale HL health back to facc-scale health
					local max = thing.hl.maxhealth or 800
					local scaledHealth = thing.hl.health or 0

					-- Normalize to a 0-1 range and multiply by expected facc max
					local phase = thing.facc.phase or 1
					local faccMax = (phase == 1 and 8)
						or (phase == 2 and (50 + min(#players, 6) * 16))
						or 100 -- fallback

					thing.facc.health = FixedCeil((scaledHealth * faccMax * FRACUNIT) / max) / FRACUNIT
				end
				if thing.breaktime or thing.breakdelay then
				
				end
			end
		elseif vplayer and type(vplayer.rings) == "number" then
			vplayer.rings = $ - FixedMul(damage, FRACUNIT*4/10)
			if vplayer.rings <= 0 then
				P_KillMobj(victim, tmthing, tmthing and tmthing.target or tmthing)
			end
		else
			HL_DamageGordon(thing, tmthing, damage, customDamageType)
		end
	end
	
	return damage
end)

function A_StopMomentum(actor)
	if not (actor and actor.valid) then return end
	actor.angle = R_PointToAngle2(0, 0, actor.momx, actor.momy)
	local horizontalSpeed = R_PointToDist2(0, 0, actor.momx, actor.momy)
	actor.pitch = -R_PointToAngle2(0, 0, horizontalSpeed, actor.momz)
	actor.momx = 0
	actor.momy = 0
	actor.momz = 0
	actor.flags = $|MF_NOGRAVITY
end

function A_HLRocketThinker(actor, speed)
	actor.momx = FixedMul(speed, cos(actor.angle)) * cos(actor.pitch)
	actor.momy = FixedMul(speed, sin(actor.angle)) * cos(actor.pitch)
	actor.momz = -FixedMul(speed, sin(actor.pitch))
end

function A_HLExplode(actor, range, baseDamage)
	if not (actor and actor.valid) then return end -- Ensure the actor exists

	-- Process breakable FOFs in affected sectors
	local function ProcessFOFs(sector)
		if sector then
			for rover in sector.ffloors() do
				if (rover.flags & FOF_BUSTUP) and (rover.flags & FOF_EXISTS) then  -- Check if the FOF is real and is breakable
					EV_CrumbleChain(sector, rover)
				end
			end
		end
	end

	local function ProcessSectorLines(refmobj, line)
		-- Check both front and back sectors of the line
		ProcessFOFs(line.frontsector)
		ProcessFOFs(line.backsector)
	end

	-- Search for lines in the affected area
	searchBlockmap("lines", ProcessSectorLines, actor, actor.x - (range/2), actor.x + (range/2), actor.y - (range/2), actor.y + (range/2))

	local function DamageAndBoostNearby(refmobj, foundmobj)
		refmobj.ignoredamagedef = true
		local dist = HL_GetDistance(refmobj, foundmobj)
		if dist > range then return end -- Only affect objects within range

		if not foundmobj or foundmobj == refmobj then return end -- Skip if no object or self
		if not P_CheckSight(refmobj, foundmobj) then return end -- Skip if we don't have a clear view
		if foundmobj.type == MT_SPIKE and not (foundmobj.state == S_SPIKED1 or foundmobj.state == S_SPIKED2) then
			P_KillMobj(foundmobj, refmobj, refmobj)
			return
		end
		if not (foundmobj.flags & MF_SHOOTABLE) then return end -- Don't attempt to hurt things that shouldn't be hurt

		-- Damage Boosting: apply shockwave momentum to boost objects
		local impulseFactor = FixedDiv(range - dist, range) -- Closer objects get a stronger boost
		local boostFactor = FRACUNIT * 36 -- Base multiplier for force
		if P_IsObjectOnGround(foundmobj) then
			boostFactor = $ / 2 -- Bad rocket jump "multiplier"
		end

		-- Compute horizontal direction and thrust
		local angle = R_PointToAngle2(refmobj.x, refmobj.y, foundmobj.x, foundmobj.y)
		local thrustPower = FixedMul(boostFactor, impulseFactor)
		P_Thrust(foundmobj, angle, thrustPower)

		-- Get the vertical thrust that we'll use later
		local heightDiff = foundmobj.z - refmobj.z
		local heightFactor = FixedDiv(abs(heightDiff), range + FRACUNIT) -- Normalize height effect
		local verticalBoost = FixedMul(boostFactor, impulseFactor) -- Base scaling
		verticalBoost = FixedMul(verticalBoost, (FRACUNIT - heightFactor)) -- Reduce if higher up

		P_SetObjectMomZ(foundmobj, verticalBoost, true)

		-- Recheck the object just in case it died from some edge case during thrust
		if not foundmobj then return end

		-- Calculate and apply damage
		local damage = max(1, FixedMul(baseDamage, FixedDiv(range - dist, range)))
		HL_HurtMobj(refmobj, foundmobj, damage, HL.DMG.BLAST)
	end

	-- Process nearby objects for damage and boosting
	searchBlockmap("objects", DamageAndBoostNearby, actor, actor.x - range, actor.x + range, actor.y - range, actor.y + range)

	-- Stop momentum and play a random explosion sound
	A_StopMomentum(actor)
	if not (actor and actor.valid) then return end
	actor.scale = FRACUNIT * 3
	S_StartSound(actor, P_RandomRange(sfx_hlexp1, sfx_hlexp3))
end

local function HL_TheRaycastingAtHome(mobj, shooter, maxHits)
	if mobj.dontraycast then return end

	shooter.flags = $ | MF_NOCLIP

	local dist = mobj.dist or MISSILERANGE / mobj.info.speed
	local elapsed = 0
	local hits = 0

	for i = 1, dist do
		if not (mobj and mobj.valid) then
			elapsed = i
			break
		end

		local hit = P_RailThinker(mobj)

		if hit then
			if hits >= (maxHits or 0) then break end
			hits = $ + 1
			-- Force the ray forward using its velocity to avoid stalling
			P_SetOrigin(mobj,
				mobj.x + mobj.momx,
				mobj.y + mobj.momy,
				mobj.z + mobj.momz)
		end

		elapsed = i
	end

	shooter.flags = $ & ~MF_NOCLIP

	return elapsed
end

function A_HLSetupLaserMine(actor, var1, var2)
    S_StartSound(actor, actor.info.attacksound)

    actor.flags = $ | MF_SOLID
    local angle = actor.angle
    local x, y, z = actor.x, actor.y, actor.z + (actor.height / 2)
    local lasertype = MT_HL1_TRIPLASER
    local info = mobjinfo[lasertype]
    local laser = P_SpawnMobjFromMobj(actor, 0, 0, 0, lasertype)

    -- Pre-calculate direction
    local dirx = cos(angle)
    local diry = sin(angle)

    laser.angle = angle + ANGLE_90
    laser.flags = $ | MF_NOCLIPTHING
    laser.momx = FixedMul(dirx, info.speed)
    laser.momy = FixedMul(diry, info.speed)

    -- Run raycast to get total distance
    local dist = HL_TheRaycastingAtHome(laser, actor.target) * info.speed
    print("Total Distance:", dist / FRACUNIT)

    -- Move laser to midpoint between Tripmine and end of laser
    local midpoint = dist / 2
	laser.flags = $ | MF_NOCLIPHEIGHT
    local midx = x - FixedMul(dirx, midpoint)
    local midy = y - FixedMul(diry, midpoint)
    local midz = z  -- Keep same height

    P_SetOrigin(laser, midx, midy, midz)
    laser.radius = midpoint
	laser.spritexscale = FixedDiv(laser.radius, FRACUNIT)
end

addHook("TouchSpecial", function()
	print("Touch!")
end, MT_HL1_TRIPLASER)

states[S_HL1_HIT] = {
	sprite = SPR_HLHITEFFECT,
	frame = A|FF_ANIMATE,
	tics = 9,
	var1 = 9,
	var2 = 1,
	nextstate = S_NULL
}

states[S_HL1_EXPLODE] = {
	sprite = SPR_HL1EXPLOSION,
	frame = A,
	action = A_HLExplode,
	tics = 0,
	var1 = 256*FRACUNIT, -- range
	var2 = 192, -- damage
	nextstate = S_HL1_EXPLOSION
}

states[S_HL1_GRENADEEXPLODE] = {
	sprite = SPR_HL1EXPLOSION,
	frame = A,
	action = A_HLExplode,
	tics = 0,
	var1 = 192*FRACUNIT, -- range
	var2 = 192, -- damage
	nextstate = S_HL1_EXPLOSION
}

states[S_HL1_EXPLOSION] = {
	sprite = SPR_HL1EXPLOSION,
	frame = A|FF_ADD|FF_ANIMATE,
	tics = 13*3,
	var1 = 13,
	var2 = 3,
	nextstate = S_NULL
}

states[S_HL1_TRIPMINETHROWN] = {
	sprite = SPR_TRIP,
	frame = A|FF_PAPERSPRITE,
	action = A_PlayActiveSound,
	tics = 0,
	var1 = 0,
	var2 = 0,
	nextstate = S_HL1_INACTIVETRIPMINE
}

states[S_HL1_INACTIVETRIPMINE] = {
	sprite = SPR_TRIP,
	frame = A|FF_PAPERSPRITE,
	action = A_PlaySound, -- SRB2 uses seesound for when the missile gets launched, so don't use it
	tics = 105,           -- ^ costs us an action, but we weren't using it anyways
	var1 = sfx_hltmch,
	var2 = 1,
	nextstate = S_HL1_ACTIVETRIPMINE
}

states[S_HL1_ACTIVETRIPMINE] = {
	sprite = SPR_TRIP,
	frame = A|FF_PAPERSPRITE,
	action = A_HLSetupLaserMine,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_HL1_EXPLODE
}

states[S_HL1_ROCKET] = {
	sprite = SPR_HL1EXPLOSION,
	frame = A,
	action = A_StopMomentum,
	tics = 18,
	var1 = 0,
	var2 = 0,
	nextstate = S_HL1_ROCKETACTIVE
}

states[S_HL1_ROCKETACTIVE] = {
	sprite = SPR_HL1EXPLOSION,
	frame = A,
	action = A_HLRocketThinker,
	tics = -1,
	var1 = 30*FRACUNIT,
	var2 = 0,
	nextstate = S_HL1_EXPLODE
}

states[S_HL1_TRIPLASER] = {
	sprite = SPR_HL1LASER,
	frame = A|FF_ADD|FF_PAPERSPRITE,
	tics = -1,
	nextstate = S_HL1_TRIPLASER
}

mobjinfo[MT_HL1_ROCKET] = {
spawnstate = S_HL1_ROCKET,
spawnhealth = 100,
deathstate = S_HL1_EXPLODE,
reactiontime = 18,
activesound = sfx_hlrckt,
speed = 30*FRACUNIT,
radius = mobjinfo[MT_CORK].radius,
height = mobjinfo[MT_CORK].height,
dispoffset = 4,
flags = MF_MISSILE|MF_NOGRAVITY,
}

mobjinfo[MT_HL1_ARGRENADE] = {
spawnstate = S_KOMBI_SHURIKEN,
spawnhealth = 100,
deathstate = S_HL1_EXPLODE,
speed = 20*FRACUNIT,
radius = mobjinfo[MT_CORK].radius,
height = mobjinfo[MT_CORK].height,
dispoffset = 4,
flags = MF_MISSILE,
}

mobjinfo[MT_HL1_HANDGRENADE] = {
	spawnstate = S_KOMBI_SHURIKEN,
	spawnhealth = 100,
	deathstate = S_HL1_GRENADEEXPLODE,
	xdeathstate = S_HL1_GRENADEEXPLODE,
	activesound = sfx_hlgrn1,
	speed = 12*FRACUNIT,
	radius = mobjinfo[MT_CORK].radius,
	height = mobjinfo[MT_CORK].height,
	dispoffset = 4,
	flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE,
}

mobjinfo[MT_HL1_SATCHEL] = {
	spawnstate = S_KOMBI_SHURIKEN,
	spawnhealth = 100,
	xdeathstate = S_HL1_EXPLODE,
	speed = 12*FRACUNIT,
	radius = mobjinfo[MT_CORK].radius,
	height = mobjinfo[MT_CORK].height,
	dispoffset = 4,
	flags = MF_SLIDEME|MF_SCENERY,
}

mobjinfo[MT_HL1_TRIPMINE] = {
	spawnstate = S_HL1_TRIPMINETHROWN,
	spawnhealth = 100,
	deathstate = S_HL1_EXPLODE,
	speed = FRACUNIT,
	radius = FRACUNIT*4,
	height = FRACUNIT*10,
	dispoffset = 4,
	flags = MF_NOGRAVITY|MF_SCENERY,
	activesound = sfx_hltmdp,
	attacksound = sfx_hltmac,
	missilestate = S_HL1_TRIPMINETHROWN
}

mobjinfo[MT_HL1_TRIPLASER] = {
	spawnstate = S_HL1_TRIPLASER,
	spawnhealth = 100,
	speed = FRACUNIT * 16,
	radius = FRACUNIT,
	height = FRACUNIT*3,
	dispoffset = 4,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_SCENERY|MF_PAPERCOLLISION,
}

rawset(_G, "VMDL_FLIP", 1)

rawset(_G, "VBOB_DOOM", 1)
rawset(_G, "VBOB_NONE", 2)
rawset(_G, "VBOB_WOLF3D", VBOB_NONE)

rawset(_G, "WEAPON_NONE", -1)

-- helper to generate a sequence of {x,y} offsets
local function genOffsets(x, y0, dy, count)
  local t = {}
  for i=1, count do
    t[i] = { x, y0 + (i-1)*dy }
  end
  return t
end

-- helper to generate a reverse sequence
local function genOffsetsReverse(x, y0, dy, count)
  local t = {}
  for i=1, count do
    t[i] = { x, y0 - (i-1)*(-dy) }
  end
  return t
end

-- Generic DOOM lower animation generator
local function makeLower(sentinel, x, y0, dy, count)
  return {
    sentinel       = sentinel,
    frameDurations = { [1]=1, [count+1]=1 },
    frameOffsets   = genOffsets(x, y0, dy, count),
  }
end

-- Generic DOOM ready animation generator
local function makeReady(sentinel, x, yMax, dy, count)
  return {
    sentinel       = sentinel,
    frameDurations = { [1]=1, [count+1]=1 },
    frameOffsets   = genOffsetsReverse(x, yMax, dy, count),
  }
end

rawset(_G, "kombihl1viewmodels", {
	["CROWBAR"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "HLCBARREADY1",
						frameDurations = {
							[1] = 3,
							[4] = 3,
						},
			},
			primaryfire = {
				normal = {
					{
						sentinel = "HLCBARFIRE1-1",
						frameDurations = {
							[1] = 2,
							[2] = 4,
							[3] = 3,
							[4] = 4,
							[5] = 3,
							[6] = 2,
						},
					},
					{
						sentinel = "HLCBARFIRE2-1",
						frameDurations = {
							[1] = 3,
							[6] = 3,
						},
					},
					{
						sentinel = "HLCBARFIRE3-1",
						frameDurations = {
							[1] = 3,
							[6] = 3,
						},
					},
				},
				hit = {
					{
						sentinel = "HLCBARHIT3-1",
						frameDurations = {
							[1] = 3,
							[5] = 3,
						},
					},
					{
						sentinel = "HLCBARHIT2-1",
						frameDurations = {
							[1] = 1,
							[2] = 2,
							[3] = 3,
							[7] = 3,
						},
					},
					{
						sentinel = "HLCBARHIT3-1",
						frameDurations = {
							[1] = 1,
							[2] = 2,
							[3] = 3,
							[7] = 3,
						},
					},
				},
			},
			idle = {
				{
					sentinel = "HLCBARIDLE1-1",
					frameDurations = {
						[1] = 10,
						[11] = 10,
					},
				},
				{
					sentinel = "HLCBARIDLE2-1",
					frameDurations = {
						[1] = 8,
						[20] = 8,
					},
				},
				{
					sentinel = "HLCBARIDLE3-1",
					frameDurations = {
						[1] = 8,
						[20] = 8,
					},
				},
			},
		},
	},
	["PISTOL"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "PISTOLREADY1",
				frameDurations = {
					[1] = 3,
					[7] = 3,
				},
			},
			primaryfire = {
				normal = {
					sentinel = "PISTOLFIRE1",
					frameDurations = {
						[1] = 2,
						[9] = 2,
					},
				},
				empty = {
					sentinel = "PISTOLFIREEMPT1",
					frameDurations = {
						[1] = 2,
						[9] = 2,
					},
				}
			},
			secondaryfire = {
				normal = {
					sentinel = "PISTOLALTFIRE1",
					frameDurations = {
						[1] = 1,
						[2] = 2,
						[8] = 2,
					},
				},
				empty = {
					sentinel = "PISTOLALTFIREEMPT1",
					frameDurations = {
						[1] = 1,
						[2] = 2,
						[10] = 2,
					},
				}
			},
			reload = {
					sentinel = "PISTOLRELOAD1",
					frameDurations = {
						[1] = 6,
						[13] = 6,
					},
					frameSounds = {
						[3] = sfx_hl1pr1,
						[9] = sfx_hl1pr2
					},
			},
			idle = {
				{
					sentinel = "PISTOLIDLE1-1",
					frameDurations = {
						[1] = 8,
						[21] = 8,
					},
				},
				{
					sentinel = "PISTOLIDLE2-1",
					frameDurations = {
						[1] = 8,
						[2] = 12,
						[10] = 12,
					},
				},
				{
					sentinel = "PISTOLIDLE3-1",
					frameDurations = {
						[1] = 8,
						[2] = 10,
						[16] = 10,
					},
				},
			},
		},
	},
	["357-"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "357READY1",
				frameDurations = {
					[1] = 3,
					[7] = 3,
				},
			},
			primaryfire = {
				sentinel = "357FIRE1",
				frameDurations = {
					[1] = 2,
					[2] = 3,
					[8] = 3,
				},
			},
			reload = {
				sentinel = "357RELOAD1",
				frameDurations = {
					[1] = 6,
					[2] = 4,
					[4] = 3,
					[22] = 3,
					[25] = 8,
					[28] = 8,
				},
				frameSounds = {
					[22] = sfx_hl357r,
				}
			},
			idle = {
				{
					sentinel = "357IDLE1-1",
					frameDurations = {
						[1] = 6,
						[2] = 5,
						[19] = 5,
					},
				},
				{
					sentinel = "357IDLE2-1",
					frameDurations = {
						[1] = 6,
						[2] = 5,
						[20] = 5,
					},
				},
				{
					sentinel = "357IDLE3-1",
					frameDurations = {
						[1] = 6,
						[2] = 15,
						[26] = 15,
					},
				},
				{
					sentinel = "357IDLE4-1",
					frameDurations = {
						[1] = 6,
						[2] = 10,
						[48] = 10,
					},
				},
			},
		},
	},
	["SHOTGUN"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "SHOTGUNREADY1",
				frameDurations = {
					[1] = 3,
					[5] = 3,
				},
			},
			primaryfire = {
				sentinel = "SHOTGUNFIRE1",
				frameDurations = {
					[1] = 3,
					[12] = 3,
				},
				frameSounds = {
					[6] = sfx_hl1sgc
				}
			},
			secondaryfire = {
				sentinel = "SHOTGUNAFIRE1",
				frameDurations = {
					[1] = 3,
					[2] = 2,
					[3] = 3,
					[4] = 2,
					[5] = 3,
					[6] = 2,
					[7] = 3,
					[8] = 2,
					[9] = 3,
					[10] = 2,
					[11] = 3,
					[12] = 2,
					[13] = 3,
					[14] = 2,
					[15] = 3,
					[16] = 2,
					[17] = 3,
					[18] = 2,
					[19] = 3,
					[20] = 6,
				},
				frameSounds = {
					[13] = sfx_hl1sgc,
				}
			},
			reload = {
				start = {
					sentinel = "SHOTGUNRELOADS1",
					frameDurations = {
						[1] = 3,
						[7] = 3,
					},
				},
				loop = {
					sentinel = "SHOTGUNRELOADL1",
					frameDurations = {
						[1] = 4,
						[6] = 4,
					},
					frameSounds = {
						[3] = {sound = sfx_hl1sr1, sounds = 3},
					}
				},
				stop = {
					sentinel = "SHOTGUNRELOADE1",
					frameDurations = {
						[1] = 4,
						[8] = 4,
					},
					frameSounds = {
						[4] = sfx_hl1sgc,
					}
				},
			},
			idle = {
				{
					sentinel = "SHOTGUNIDLE1-1",
					frameDurations = {
						[1] = 8,
						[10] = 8,
					},
				},
				{
					sentinel = "SHOTGUNIDLE2-1",
					frameDurations = {
						[1] = 8,
						[12] = 5,
					},
				},
				{
					sentinel = "SHOTGUNIDLE3-1",
					frameDurations = {
						[1] = 8,
						[2] = 10,
						[18] = 16,
					},
				},
			},
		}
	},
	["MP5-"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "MP5READY1",
				frameDurations = {
					[1] = 5,
					[3] = 8,
				},
			},
			primaryfire = {
				{
					sentinel = "MP5FIRE1-1",
					frameDurations = {
						[1] = 5,
						[5] = 5,
					},
				},
				{
					sentinel = "MP5FIRE2-1",
					frameDurations = {
						[1] = 5,
						[2] = 4,
						[5] = 4,
					},
				},
				{
					sentinel = "MP5FIRE3-1",
					frameDurations = {
						[1] = 5,
						[2] = 4,
						[5] = 4,
					},
				},
			},
			secondaryfire = {
				sentinel = "MPARGRENADE1",
				frameDurations = {
					[1] = 5,
					[6] = 5,
				}
			},
			reload = {
				sentinel = "MP5RELOAD1",
				frameDurations = {
					[1] = 5,
					[2] = 4,
					[13] = 4,
				},
				frameSounds = {
					[1] = sfx_hlarr1,
					[7] = sfx_hlarr2,
				}
			},
			idle = {
				{
					sentinel = "MP5IDLE1-1",
					frameDurations = {
						[1] = 10,
						[11] = 10,
					},
				},
				{
					sentinel = "MP5IDLE2-1",
					frameDurations = {
						[1] = 5,
						[2] = 6,
						[30] = 6,
					},
				},
			},
		}
	},
	["GRENADE"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "GRENADEREADY1",
				frameDurations = {
					[1] = 2,
					[6] = 2,
				},
			},
			primaryfire = {
				sentinel = "GRENADETHROW1",
				frameDurations = {
					[1] = 2,
					[11] = 2,
				},
			},
			startcook = {
				sentinel = "GRENADEFIRE1",
				frameDurations = {
					[1] = 3,
					[7] = 3,
				},
				next = "cookloop"
			},
			cookloop = {
				sentinel = "GRENADEREADY1",
				frameDurations = {
					[1] = 10,
				},
				loop = true
			},
			reload = {
				sentinel = "MP5RELOAD1",
				frameDurations = {
					[1] = 5,
					[2] = 4,
					[13] = 4,
				},
				frameSounds = {
					[1] = sfx_hlarr1,
					[7] = sfx_hlarr2,
				}
			},
			idle = {
				{
					sentinel = "GRENADEIDLE1-1",
					frameDurations = {
						[1] = 3,
						[20] = 3,
					},
				},
				{
					sentinel = "GRENADEIDLE2-1",
					frameDurations = {
						[1] = 4,
						[27] = 4,
					},
				},
			},
		}
	},
	["CROSSBOW"] = {
		flags = VMDL_FLIP,
		animations = {
			ready = {
				sentinel = "CROSSBOWREADY1",
				frameDurations = {
					[1] = 2,
					[8] = 2,
				},
			},
			primaryfire = {
				normal = {
					sentinel = "CROSSBOWFIRE1",
					frameDurations = {
						[1] = 2,
						[2] = 3,
						[3] = 2,
						[4] = 3,
						[5] = 2,
						[6] = 3,
						[7] = 2,
						[10] = 3,
						[12] = 2,
						[13] = 3,
						[14] = 2,
						[15] = 3,
						[16] = 2,
						[17] = 3,
						[18] = 2,
						[19] = 3,
						[20] = 2,
						[21] = 3,
						[22] = 2,
						[23] = 3,
						[24] = 2,
						[25] = 3,
						[26] = 2,
						[27] = 3,
						[28] = 2,
						[29] = 3,
					},
					frameSounds = {
						[0] = sfx_hlxbre
					}
				},
				empty = {
					sentinel = "CROSSBOWFIREEMPT1",
					frameDurations = {
						[1] = 3,
						[6] = 3,
					}
				},
			},
			reload = {
				sentinel = "CROSSBOWRELOAD1",
				frameDurations = {
					[1] = 4,
					[38] = 4,
				},
				frameSounds = {
					[3] = sfx_hlxbre,
				}
			},
			idle = {
				{
					sentinel = "CROSSBOWIDLE1-1",
					frameDurations = {
						[1] = 6,
						[27] = 6,
					},
				},
				{
					sentinel = "CROSSBOWIDLE2-1",
					frameDurations = {
						[1] = 5,
						[22] = 5,
					},
				}
			},
			emptyidle = {
				sentinel = "CROSSBOWIDLEEMPT1",
				frameDurations = {
					[1] = 7,
					[10] = 7,
				},
			},
		},
	},
    WP2 = { -- DOOM Pistol
      idleanims = 1,
      bobtype   = VBOB_DOOM,
      animations = {
        lower       = makeLower("WP2IDLE1", 0,   6,  6, 22),
        ready       = makeReady("WP2IDLE1", 0, 132, -6, 22),
        primaryfire = { sentinel="WP2FIRE1", frameDurations={1,2,3} },
        reload      = { sentinel="WP2IDLE1",  frameDurations={6} },
        idle        = { sentinel="WP2IDLE1",  frameDurations={ INT32_MAX } },
      },
    },
    WP3 = { -- DOOM Shotgun
      idleanims = 1,
      bobtype   = VBOB_DOOM,
      animations = {
        lower       = makeLower("WP3IDLE1", 0,   6,  6, 22),
        ready       = makeReady("WP3IDLE1", 0, 132, -6, 22),
        primaryfire = {
            sentinel       = "WP3FIRE1",
            frameDurations = {4,3,5,4,5,nil,3,7},
        },
        reload      = { sentinel="WP3IDLE1", frameDurations={6} },
        idle        = { sentinel="WP3IDLE1", frameDurations={ INT32_MAX } },
      },
    },
	["WP3A"] = {  -- Super-Shotgun
	  idleanims = 1,
	  bobtype   = VBOB_DOOM,
	  animations = {
		lower = makeLower("WP3IDLE1", 0,   6,  6, 22),
		ready = makeReady("WP3IDLE1", 0, 132, -6, 22),
		primaryfire = {
		  sentinel       = "WP3AFIRE1",
		  frameDurations = {
			[1] = 6,
			[3] = 8,
			[4] = 14,
			[9] = 10,
			[10] = 12,
		  },
		  frameSounds = {
			[5] = sfx_ssgo,
			[7] = sfx_ssgl,
			[9] = sfx_ssgc,
		  },
		},
		reload = {
		  sentinel       = "WP3AIDLE1",
		  frameDurations = {
			[1] = 6,
		  },
		},
		idle = {
		  sentinel       = "WP3AIDLE1",
		  frameDurations = {
			[1] = INT32_MAX,
		  },
		},
	  },
	},
	["WP4"] = {  -- Chaingun
	  idleanims = 1,
	  bobtype   = VBOB_DOOM,
	  animations = {
		lower = makeLower("WP3IDLE1", 0,   6,  6, 22),
		ready = makeReady("WP3IDLE1", 0, 132, -6, 22),
		primaryfire = {
		  sentinel       = "WP4FIRE1",
		  frameDurations = {
			[1] = 2,
			[2] = 2,
		  },
		},
		reload = {
		  sentinel       = "WP4IDLE1",
		  frameDurations = {
			[1] = 6,
		  },
		},
		idle = {
		  sentinel       = "WP4IDLE1",
		  frameDurations = {
			[1] = INT32_MAX,
		  },
		},
	  },
	},
	DUKEPIST = { -- Duke3D Pistol
      idleanims = 1,
      bobtype   = VBOB_DOOM,
      animations = {
        ready       = { sentinel="DUKEPISTIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="DUKEPISTFIRE1", frameDurations={1,nil} },
        reload      = { sentinel="DUKEPISTRELOAD1", frameDurations={5, 7, 1, 1, 1, 3, 4, 3}, overlays = { {sentinel = "DUKEPISTRELHAND1", layer = {0, 0, 1, 1, 1, -1, -1, 0} } } },
        idle        = { sentinel="DUKEPISTIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
	DUKESHOT = { -- Duke3D Shotgun
      idleanims = 1,
      bobtype   = VBOB_DOOM,
      animations = {
        ready       = { sentinel="DUKESHOTIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="DUKESHOTFIRE1", frameDurations={3,1,1,3,4,3,6,3,5,5}, overlays = { {sentinel = "DUKESHOTFMUZ1"} } },
        reload      = { sentinel="DUKESHOTIDLE1",  frameDurations={6} },
        idle        = { sentinel="DUKESHOTIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
	WOLFKNIF = { -- Wolf3D Knife
      idleanims = 1,
      bobtype   = VBOB_WOLF3D,
	  size      = 2*FRACUNIT,
      animations = {
        ready       = { sentinel="WOLFKNIFIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="WOLFKNIFFIRE1", frameDurations={3,3,3,3} },
        reload      = { sentinel="WOLFKNIFIDLE1",  frameDurations={6} },
        idle        = { sentinel="WOLFKNIFIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
	WOLFPIST = { -- Wolf3D Pistol
      idleanims = 1,
      bobtype   = VBOB_WOLF3D,
	  size      = 2*FRACUNIT,
      animations = {
        ready       = { sentinel="WOLFPISTIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="WOLFPISTFIRE1", frameDurations={3,3,3,3} },
        reload      = { sentinel="WOLFPISTIDLE1",  frameDurations={6} },
        idle        = { sentinel="WOLFPISTIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
	WOLFMACH = { -- Wolf3D Machine Gun
      idleanims = 1,
      bobtype   = VBOB_WOLF3D,
	  size      = 2*FRACUNIT,
      animations = {
        ready       = { sentinel="WOLFMACHIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="WOLFMACHFIRE1", frameDurations={2,2,2,2} },
        reload      = { sentinel="WOLFMACHIDLE1",  frameDurations={6} },
        idle        = { sentinel="WOLFMACHIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
	WOLFCHAI = { -- Wolf3D Chaingun
      idleanims = 1,
      bobtype   = VBOB_WOLF3D,
	  size      = 2*FRACUNIT,
      animations = {
        ready       = { sentinel="WOLFCHAIIDLE1",  frameDurations={ 1 } },
        primaryfire = { sentinel="WOLFCHAIFIRE1", frameDurations={2,2,2,2} },
        reload      = { sentinel="WOLFCHAIIDLE1",  frameDurations={6} },
        idle        = { sentinel="WOLFCHAIIDLE1",  frameDurations={ INT32_MAX } },
      },
    },
})

rawset(_G, "HL_WpnStats", {
	["crowbar"] =
	{
		viewmodel = "CROWBAR", -- the graphic we'll use for the weapon. Graphic format is VMDL[vmdlkey][baseFrameIndex]!!
		vmdlflip = true,
		selectgraphic = "HL1HUDCROWBAR",
		autoswitchweight = 0,
		weaponslot = 1,
		priority = 1,
		killicon = "HLKILLCROWBAR",
		primary = {
			israycaster = true, -- determines if the bullet object takes the guy with the lightning's advice if it doesn't hit anything (and applies a distance limit)
			ammo = "melee",
			ismelee = true, -- Gets affected by DoomGuy's berserk if set to true.
			clipsize = WEAPON_NONE,
			shotcost = 0,
			damage = 5,
			firesound = sfx_hlcbar,
			firehitsound = sfx_hlcbh1,
			firehitsounds = 2,
			maxdistance = FixedMul(MELEERANGE, FRACUNIT*3/2),
			firedelay = 18,
			hitdelay = 9,
		},
		altfire = false,
		globalfiredelay = {
			ready = 12,
		},
		realname = "Crowbar",
	},
	["9mmhandgun"] =
		{
		viewmodel = "PISTOL",
		crosshair = "XHRPIS",
		selectgraphic = "HL1HUD9MM",
		autoswitchweight = 10,
		weaponslot = 2,
		priority = 1,
		killicon = "HLKILL9MM",
		nounderwater = true,
		primary = {
			ammo = "9mm",
			israycaster = true,
			pickupgift = 17,
			clipsize = 17,
			shotcost = 1,
			damage = 8,
			refireusesspread = true,
			horizspread = 5*FRACUNIT,
			vertspread = 5*FRACUNIT,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 12,
		},
		autoreload = true,
		secondary = {
			ammo = "none",
			israycaster = true,
			clipsize = WEAPON_NONE,
			shotcost = 1,
			horizspread = 5,
			vertspread = 5,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 6,
		},
		altfire = true,
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 12,
			reload = 53,
			reloadpost = 18,
		},
		realname = "9mm Handgun",
	},
	["357"] =
		{
		viewmodel = "357-",
		crosshair = "XHR357",
		selectgraphic = "HL1HUD357",
		autoswitchweight = 15,
		weaponslot = 2,
		priority = 2,
		killicon = "HLKILL357",
		primary = {
			ammo = "357",
			israycaster = true,
			clipsize = 6,
			pickupgift = 6,
			shotcost = 1,
			damage = 50,
			horizspread = 0,
			vertspread = 0,
			kickback = 7*FRACUNIT,
			firesound = sfx_hl3571,
			firesounds = 2,
			firedelay = 26,
		},
		secondary = {
			firefunc = function()
				return true
			end
		},
		autoreload = true,
		altfire = true,
		secondary = {
			firefunc = function(player, mystats)
				if multiplayer then
					player.hl.zoomed = not $
				end
				return true
			end,
			firedelay = 18,
		},
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 18,
			reload = 92
		},
		realname = ".357",
	},
	["mp5"] =
		{
		viewmodel = "MP5-",
		crosshair = "XHR9MM",
		selectgraphic = "HL1HUDMP5",
		autoswitchweight = 15,
		weaponslot = 3,
		priority = 1,
		killicon = "HLKILLMP5",
		nounderwater = true,
		primary = {
			pickupgift = 25,
			ammo = "9mm",
			israycaster = true,
			clipsize = 50,
			shotcost = 1,
			damage = 5,
			horizspread = 4*FRACUNIT,
			vertspread = 4*FRACUNIT,
			kickback = 1*FRACUNIT,
			kickbackcanflip = true,
			firesound = sfx_hl1ar1,
			firesounds = 3,
			firedelay = 4,
		},
		secondary = {
			pickupgift = 2,
			noreserveammo = true,
			ammo = "argrenade",
			killicon = "HLKILLGRENADEAR",
			clipsize = WEAPON_NONE,
			shotcost = 1,
			kickback = 10*FRACUNIT,
			firesound = sfx_hlarg1,
			explosionradius = 192*FRACUNIT,
			firesounds = 2,
			firedelay = 20,
		},
		globalfiredelay = {
			ready = 12,
			reload = 53
		},
		realname = "MP5",
	},
	["shotgun"] =
		{
		viewmodel = "SHOTGUN",
		crosshair = "XHRSHOT",
		selectgraphic = "HL1HUDSHOTGUN",
		autoswitchweight = 15,
		weaponslot = 3,
		priority = 2,
		killicon = "HLKILLSHOTGUN",
		nounderwater = true,
		primary = {
			reloadincrement = 1,
			israycaster = true,
			ammo = "buckshot",
			pellets = 6,
			clipsize = 8,
			shotcost = 1,
			pickupgift = 12, -- why does the shotgun have 12 shells in it? is it stupid?
			damage = 5,
			horizspread = 7*FRACUNIT,
			vertspread = 5*FRACUNIT,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1sg1,
			firedelay = 36,
		},
		autoreload = true,
		secondary = {
			ammo = "none",
			israycaster = true,
			pellets = 12,
			clipsize = WEAPON_NONE,
			shotcost = 2,
			damage = 5,
			horizspread = 56*FRACUNIT/5,
			vertspread = 71*FRACUNIT/10,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hldsht,
			firedelay = 59,
		},
		altfire = true,
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 12,
			["reloadstart"] = 18,
			["reloadloop"] = 20,
		},
		realname = "SPAS-12",
	},
	["crossbow"] =
		{
		viewmodel = "CROSSBOW",
		crosshair = "XHRXBW",
		selectgraphic = "HL1HUDCROSSBOW",
		autoswitchweight = 10,
		weaponslot = 3,
		priority = 3,
		killicon = "HLKILLCROSSBOW",
		primary = {
			ammo = "bolt",
			clipsize = 5,
			shotcost = 1,
			pickupgift = 5,
			damage = 50,
			kickback = 3*FRACUNIT,
			firesound = sfx_hlxbfr,
			firedelay = 24,
			explodeonhit = function()
				return cv_deathmatch.value
			end,
			explosiondamage = 60,
			explosionradius = 96 * FRACUNIT,
		},
		autoreload = true,
		secondary = {
			firefunc = function(player, mystats)
				player.hl.zoomed = not $
				player.weaponaltdelay = TICRATE/2
				return true
			end,
			firedelay = 18,
		},
		altfire = true,
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 16,
			reload = 104,
			reloadpost = 48,
		},
		realname = "Crossbow",
	},
	-- everything past this point has unfinished properties!!
/*
	["rpg"] =
		{
		viewmodel = "PISTOL",
		crosshair = "XHRRPG",
		selectgraphic = "HL1HUDRPG",
		autoswitchweight = 20,
		weaponslot = 4,
		priority = 1,
		killicon = "HLKILLRPG",
		nounderwater = true,
		primary = {
			pickupgift = 1,
			ammo = "rocket",
			clipsize = 5,
			shotcost = 1,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 35,
		},
		autoreload = true,
		altfire = false,
		globalfiredelay = {
			ready = 15,
			["normal"] = 35,
			reload = 36,
			["reloadpost"] = 24,
		},
		realname = "Rocket Launcher",
	},
	["gauss"] =
	{
		viewmodel = "PISTOL",
		crosshair = "XHRGAUS",
		selectgraphic = "HL1HUDTAU",
		autoswitchweight = 20,
		pickupgift = 20,
		weaponslot = 4,
		priority = 2,
		killicon = "HLKILLTAU",
		nounderwater = true,
		primary = {
			ammo = "uranium",
			israycaster = true,
			clipsize = WEAPON_NONE,
			shotcost = 1,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 12,
		},
		autoreload = true,
		altfire = false,
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 12,
			["normal"] = 12,
			["alt"] = 6,
			reload = 54,
		},
		realname = "Tau Cannon",
	},

	["egon"] =
	{
		viewmodel = "PISTOL",
		crosshair = "XHREGON",
		selectgraphic = "HL1HUDGAUSS",
		autoswitchweight = 20,
		pickupgift = 20,
		weaponslot = 4,
		priority = 3,
		killicon = "HLKILLGLUON",
		nounderwater = true,
		primary = {
			ammo = "uranium",
			israycaster = true,
			clipsize = WEAPON_NONE,
			shotcost = 1,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 12,
		},
		autoreload        = true,
		altfire           = false,
		altusesprimaryclip= true,
		globalfiredelay = {
			ready = 12,
			["normal"] = 12,
			["alt"] = 6,
			reload = 54,
		},
		realname = "Gluon Gun",
	},

	["hornetgun"] =
	{
		viewmodel = "PISTOL",
		crosshair = "XHRHNET",
		selectgraphic = "HL1HUDHORNET",
		autoswitchweight = 15,
		weaponslot = 4,
		priority = 4,
		killicon = "HLKILLHIVEHAND",
		primary = {
			ammo = "hornet",
			clipsize = WEAPON_NONE,
			shotcost = 1,
			kickback = 5*FRACUNIT/2,
			firesound = sfx_hl1g17,
			firedelay = 12,
		},
		autoreload = true,
		altfire = false,
		altusesprimaryclip = true,
		globalfiredelay = {
			ready = 12,
			reload = 54,
		},
		realname = "Hivehand",
	},
*/
	["handgrenade"] =
		{
		viewmodel = "GRENADE",
		selectgraphic = "HL1HUDGRENADE",
		autoswitchweight = 5,
		weaponslot = 5,
		priority = 1,
		killicon = "HLKILLGRENADEAR",
		primary = {
			carrymomentum = true,
			pickupgift = 5,
			ammo = "grenade",
			clipsize = WEAPON_NONE,
			fuse = 3*TICRATE,
			cookable = true,
			shotcost = 1,
			damage = 1,
			firesound = sfx_none,
			firedelay = 12,
		},
		autoreload = true,
		altfire = false,
		globalfiredelay = {
			ready = 12,
			reload = 54,
		},
		realname = "Grenades",
	},
	["satchel"] =
		{
		viewmodel = "PISTOL",
		selectgraphic = "HL1HUDSATCHEL",
		autoswitchweight = 5,
		weaponslot = 5,
		priority = 2,
		killicon = "HLKILLSATCHEL",
		primary = {
			pickupgift = 1,
			ammo = "satchel",
			maxdeploy = 30,
			carrymomentum = true,
			clipsize = WEAPON_NONE,
			shotcost = 1,
			firesound = sfx_none,
			firedelay = 12,
			parenttofirer = true,
		},
		secondary = {
			ammo = "none",
			neverdenyuse = true,
			firefunc = function(player)
				for k, mobj in pairs(player.hl.objects.satchel) do
					mobj.state = S_HL1_EXPLOSION
					A_HLExplode(mobj, 192*FRACUNIT, 192)
				end
				player.hl.objects.satchel = {}
				return true
			end
		},
		altfire = true,
		globalfiredelay = {
			ready = 12,
			["alt"] = 6,
			reload = 54,
		},
		realname = "Satchels",
	},
/*
	["tripmine"] =
		{
		viewmodel = "PISTOL",
		selectgraphic = "HL1HUDTRIPMINE",
		autoswitchweight = -10, -- VERY unlikely we'll even need to check past here.
		weaponslot = 5,
		priority = 3,
		killicon = "HLKILLTRIPMINE",
		primary = {
			pickupgift = 1,
			ammo = "tripmine",
			israycaster = true,
			clipsize = WEAPON_NONE,
			shotcost = 1,
			firesound = sfx_none,
			firedelay = 12,
			maxdistance = MELEERANGE,
		},
		autoreload = true,
		altfire = false,
		globalfiredelay = {
			ready = 12,
			["normal"] = 12,
			["alt"] = 6,
			reload = 54,
		},
		realname = "Tripmines",
	},
	["snark"] = {
		viewmodel = "PISTOL",
		selectgraphic = "HL1HUDSNARK",
		autoswitchweight = -10,
		weaponslot = 5,
		priority = 4,
		killicon = "HLKILLSNARK",
		primary = {
			ammo = "snark",
			clipsize = WEAPON_NONE,
			shotcost = 1,
			pickupgift = 5,
			firesound = sfx_none,
			equipframeSound = sfx_none,
			firedelay = 12,
		},
		autoreload = true,
		altfire = false,
		globalfiredelay = {
			ready = 12,
			reload = 54,
		},
		realname = "Snarks",
	}
*/
})

rawset(_G, "HL_AmmoStats", {
	["9mm"] = {
		max = 250, -- How much of an ammo type the player can hold.
		icon = "AMMOTYPE9MM",
		-- shootmobj omitted because the MT_* that'd go here is the last resort, anyway.
	},
	["357"] = {
		max = 36,
		icon = "AMMOTYPE357",
	},
	["buckshot"] = {
		max = 125,
		icon = "AMMOTYPEBUCKSHOT",
	},
	["bolt"] = {
		max = 50,
		icon = "AMMOTYPEARROW",
		shootmobj = MT_HL1_BOLT -- the default mobj to shoot if left unspecified.
	},
	["rocket"] = {
		max = 5,
		shootmobj = MT_HL1_ROCKET,
		icon = "AMMOTYPEROCKET",
		safetycatch = true, -- disable autofire so we don't suddenly eat rockets if we autoswitch to the RPG.
		explosionradius = 128
	},
	["grenade"] = {
		max = 10,
		shootmobj = MT_HL1_HANDGRENADE,
		icon = "AMMOTYPEGRENADE",
		weapongive = "handgrenade", -- What weapon to give if we attain this ammo
		weapontake = "handgrenade", -- What weapon to take if ammo is depleted
		safetycatch = true
	},
	["satchel"] = {
		max = 5,
		icon = "AMMOTYPESATCHEL",
		weapongive = "satchel",
		weapontake = "satchel",
		shootmobj = MT_HL1_SATCHEL,
		safetycatch = true
	},
	["tripmine"] = {
		max = 5,
		icon = "AMMOTYPETRIPMINE",
		weapongive = "tripmine",
		weapontake = "tripmine",
		shootmobj = MT_HL1_TRIPMINE,
		safetycatch = true
	},
	["snark"] = {
		max = 15,
		icon = "AMMOTYPESNARK",
		weapongive = "snark",
		weapontake = "snark",
		shootmobj = MT_HL1_SNARK,
		safetycatch = true
	},
	["uranium"] = {
		max = 100,
		icon = "AMMOTYPEURANIUM",
	},
	["hornet"] = {
		max = 8,
		rechargerate = TICRATE/2, -- how long until we get more of this.
		rechargeamount = 1, -- how many of this we get.
		shootmobj = MT_HL1_HORNET,
		icon = "AMMOTYPEHORNET",
	},
	["argrenade"] = {
		max = 10,
		icon = "AMMOTYPEARGRENADE",
		shootmobj = MT_HL1_ARGRENADE,
		explosionradius = 128
	},
	-- DOOM
	-- shootmobj properties are put in here when the DoomGuy addon gets loaded in. Default to nothing extra for errors' sake.
	["bull"] = {
		max = 200,
		icon = "AMMOTYPE9MM",
	},
	["shel"] = {
		max = 50,
		icon = "AMMOTYPEBUCKSHOT",
	},
	["rckt"] = {
		max = 50,
		icon = "AMMOTYPEROCKET",
		safetycatch = true,
		explosionradius = 128
	},
	["cell"] = {
		max = 300,
		icon = "AMMOTYPEURANIUM",
	},
})

rawset(_G, "HL_PickupStats", {
})